![banner](https://github.com/nicola-bastianello/tvopt/blob/main/images/tvopt%201900x600.png)

# Welcome to **tvopt** [![Documentation Status](https://readthedocs.org/projects/tvopt/badge/?version=latest)](https://tvopt.readthedocs.io/en/latest/?badge=latest)
[**Docs**](https://tvopt.readthedocs.io/en/latest/)
| [**Installation**](#installation)
| [**Cite**](#cite)


**tvopt** is a prototyping and benchmarking Python framework for time-varying (or online) optimization. The framework is modular,
and provides different tools for modeling dynamic optimization problems and to solve them with a wide range of well known
algorithms.

The documentation is available [here](https://tvopt.readthedocs.io/en/latest/).
 

## Installation
**tvopt** works on Python 3.7 and depends on: numpy, scipy.

### pip installation
```
pip install tvopt
```

## Cite

```
@inproceedings{bastianello_tvopt_2021,
	title = {tvopt: {A} {Python} {Framework} for {Time}-{Varying} {Optimization}},
	doi = {10.1109/CDC45484.2021.9683695},
	booktitle = {2021 60th {IEEE} {Conference} on {Decision} and {Control} ({CDC})},
	author = {Bastianello, Nicola},
	year = {2021},
	pages = {227--232},
}

```

## Author
**tvopt** is developed by
[Nicola Bastianello](https://nicola-bastianello.it)
